/*
 *  FILE    : CommunityTableModel.java
 *  Ver     : 1.0      (Nov., `99)
 *  AUHTHOR : Norka Lucena
 *            norka@napc.syr.edu
 *
 */


import java.awt.*;
import java.util.Vector;
import javax.swing.*;
import javax.swing.table.*;

                    
public class CommunityTableModel extends AbstractTableModel {
    public CommunityTableModel(Vector _d, Vector _cn) {
        super();
        data = _d;
        names = _cn;
    }
    
    public int getColumnCount() {
        return names.size();
    }
    
    public int getRowCount() {
        return data.size();
    }            
            
    public Object getValueAt(int row, int col) {
        Community element = (Community) data.elementAt(row);
        if(col == 0)
            return element.getName();
        else
            return element.getStatus();
    }
    
    public String getColumnName(int col) {
        return (String) names.elementAt(col);
    }
            
    public Class getColumnClass(int col) {
        Community element = (Community) data.elementAt(0);
        if(col == 0)
            return element.getName().getClass();
        else
            return element.getStatus().getClass();
    }
 
	public boolean isCellEditable(int row, int col) {
		return false;
	}
	
	
    public void setValueAt(Object value, int row, int col) {
        if((value instanceof String && col == 0) ||
           (value instanceof String && col == 1)) { 
            // get element in row (vector of columns)
            Community element = (Community) data.elementAt(row);
            // modify data in column
            if(col == 0)
                element.setName((String) value);
            else
                element.setStatus((String) value);
            // modify element in row
            data.setElementAt(element, row);
            fireTableCellUpdated(row, col);
        }
    }
          
    public void addRow(Community rowData) {
        data.addElement(rowData);
        fireTableRowsInserted(data.size() - 1, data.size() - 1);
    }
    
    public void removeRow(int row) {
        data.removeElementAt(row);
        fireTableRowsDeleted(data.size() - 1, data.size() - 1);
    }
       
    protected Vector names;
    protected Vector data;  
}
